Subject: Re: bug#54016: 29.0.50; TRAMP + sshfs says constantly that file changed

From: Ergus <[email-masked]>
Date: Wed, 16 Feb 2022 11:57:59 +0100

On Wed, Feb 16, 2022 at 09:28:13AM +0100, Michael Albinus wrote:
>Ergus via "Bug reports for GNU Emacs, the Swiss army knife of text
>editors" <[email-masked]> writes:
>
>> Hi:
>
>Hi,
>
>> Using tramp+sshfs it works pretty much fine at the beginning but after
>> some minutes it interrupts constantly saying that the file changed on
>> disk and asks for edit confirmation.
>>
>> By constantly I mean every time a new edit is attempt I get this (even
>> several times consecutive).
>>
>> ```
>> Saving file /sshfs:XXX:XXXX
>> benchmarks_ompss.h has changed since visited or saved.  Save anyway? (y or n) y
>> benchmarks_ompss.h changed on disk; really edit the buffer? (y, n, r or C-h) y
>> File on disk now will become a backup file if you save these changes.
>> Wrote /sshfs:XXX:XXXX
>> ```
>
>Well, I would need a recipe to reproduce. Could you run it, when
>tramp-verbose is set to 10? And please tell me at which time the problem
>starts to appear, so I have a chance to find it in the debug buffer.
>
Hi:

I just open a file with /sshfs: and write something C-x C-s wait some
seconds (10) and then try to write again I get the error.

There is also some threads in stackoverflow mentioning this same issue
trams+sshfs.

https://stackoverflow.com/questions/9387202/emacs-gives-warning-when-trying-to-save-files-over-sshfs

>I know that the debug buffer will be huge after a while, but there is no
>problem if you send it directly to me (or a URL where I could find it).
>
Attached, the issue appeared after just some seconds this time:

jacobi_task_ompss2.c changed on disk; really edit the buffer? (y, n, r or C-h) y
File on disk now will become a backup file if you save these changes.

>> I have enabled auto revert with this variables since ever:
>>
>> auto-revert-verbose nil
>> auto-revert-avoid-polling t
>>
>> but this is the first time I experiment such issue.
>
>The sshfs Tramp method does not support (remote) file
>notifications. Auto-revert could work only with polling for this method.
>
I know, that's why I was wondering. Also in my config the
auto-revert-verbose nil reduces the verbosity in general, but I still
get it on tram.

>> Best,
>> Ergus
>Best regards, Michael.